| Home | Libraries | People | FAQ | More

#### read (6 of 8 overloads)

Attempt to read a certain amount of data from a stream before returning.

    template<
        typename SyncReadStream,
        typename Allocator>
    std::size_t read(
        SyncReadStream & s,
        basic_streambuf< Allocator > & b,
        boost::system::error_code & ec);

This function is used to read a certain number of bytes of data from a stream. The call will block until one of the following conditions is true:

- The supplied buffer is full (that is, it has reached maximum size).
- An error occurred.

This operation is implemented in terms of zero or more calls to the stream's read_some function.

###### Parameters

s

  The stream from which the data is to be read. The type must support the SyncReadStream concept.

b

  The `basic_streambuf` object into which the data will be read.

ec

  Set to indicate what error occurred, if any.

###### Return Value

The number of bytes transferred.

###### Remarks

This overload is equivalent to calling:

    boost::asio::read(
        s, b,
        boost::asio::transfer_all(), ec);